package org.processmining.datapetrinets.dsl;

public class DPNBuildingError extends RuntimeException {

	private static final long serialVersionUID = -3569730392563491423L;

	private final Token token;

	private int[][] expectedTokenSequence;
	private String[] tokenImage;

	public DPNBuildingError(Token token) {
		super();
		this.token = token;
	}

	public DPNBuildingError(Token token, String message, Throwable cause) {
		super(message, cause);
		this.token = token;
	}

	public DPNBuildingError(Token token, String message) {
		super(message);
		this.token = token;
	}

	public DPNBuildingError(Token token, Throwable cause) {
		super(cause);
		this.token = token;
	}

	public Token getToken() {
		return token;
	}

	public String toString() {
		return token.toString();
	}

	public int[][] getExpectedTokenSequence() {
		return expectedTokenSequence;
	}

	public String[] getTokenImage() {
		return tokenImage;
	}

	public void setExpectedTokenSequence(int[][] expectedTokenSequence) {
		this.expectedTokenSequence = expectedTokenSequence;
	}

	public void setTokenImage(String[] tokenImage) {
		this.tokenImage = tokenImage;
	}

	public boolean isNestedParseException() {
		return expectedTokenSequence != null && tokenImage != null;
	}

}
