package org.processmining.datapetrinets.validation;

import java.util.Date;

import javax.swing.JOptionPane;

import org.cpntools.accesscpn.engine.highlevel.LocalCheckFailed;
import org.cpntools.accesscpn.model.PetriNet;
import org.processmining.contexts.uitopia.UIPluginContext;
import org.processmining.contexts.uitopia.annotations.UITopiaVariant;
import org.processmining.datapetrinets.DataPetriNet;
import org.processmining.framework.plugin.annotations.Plugin;
import org.processmining.framework.plugin.annotations.PluginLevel;

public class DPNSoundness {
	@Plugin(name = " Compute Soundness of a Data Petri Net", level = PluginLevel.Regular, parameterLabels = {
	"Petri Net" }, returnLabels = { "Colour Petri Net" }, returnTypes = {
			CPNAnalysisResults.class }, userAccessible = true, keywords = { "DPN",
	"conversion" }, help = "Compute Soundness of a Data Petri Net by computing the reachability graph")

	@UITopiaVariant(affiliation = UITopiaVariant.EHV, author = "M. de Leoni", email = "m.d.leoni@tue.nl")
	public static CPNAnalysisResults convertFromPetriNet(UIPluginContext context, DataPetriNet dpn) throws Exception  {
		try
		{
			PetriNet interm = ConvertToCPNTools.convertFromPetriNet(context, dpn);
			Date startTime=new Date();
			CPNAnalysisResults retValue= SoundnessOfPetriNets.analysisCPN(context, interm, dpn);
			System.out.println("Analysis Result: "+(new Date().getTime()-startTime.getTime()));
			return retValue;
		}
		catch(LocalCheckFailed err)
		{
			String message=err.getMessage();
			message=message.replace("Object on page `RootPage'", "Modify the Petri net and run the plug-in again:\nA transition or place ");
			message=message.replaceFirst("_[0-9]+", "");
			JOptionPane.showMessageDialog(null, message,"The net needs some transition/place renaming!",JOptionPane.ERROR_MESSAGE);
			context.getFutureResult(0).cancel(true);
			return null;
		}
	}
}
