package org.processmining.datapetrinets.visualization.graphviz;

import java.util.Map;

import org.processmining.datapetrinets.expression.GuardExpression;
import org.processmining.models.graphbased.directed.petrinet.elements.Transition;
import org.processmining.plugins.graphviz.dot.DotNode;

import com.google.common.collect.ImmutableMap;

class TransitionNode extends DotNode {

	//transition
	public TransitionNode(Transition transition, String label) {
		this(transition, label, ImmutableMap.<String, String>of());
	}

	//tau transition
	public TransitionNode(Transition t) {
		this(t, "", ImmutableMap.of("width", "0.15", "fillcolor", "black", "style", "filled"));
	}

	//tau transition with guard
	public TransitionNode(Transition transition, GuardExpression guard) {
		this(transition, "",
				ImmutableMap.of("width", "0.15", "fillcolor", "black", "style", "filled", "peripheries", "2"));
	}

	//transition with guard		
	public TransitionNode(Transition transition, String label, GuardExpression guard) {
		this(transition, label, ImmutableMap.<String, String>of("peripheries", "2"));
	}

	private TransitionNode(final Transition transition, String label, Map<String, String> options) {
		super(label, ImmutableMap.<String, String>builder().putAll(options)
				.putAll(ImmutableMap.of("shape", "box", "penwidth", "2", "fontsize", "28")).build());
	}

}